#
# externe Programme via exec und grafische Ausgabe
# Zyklus-Steuerung via after
#

# Programmfester definieren/konfigurieren/oeffnen
canvas .c -width 370 -height 100
.c create text 15 10 -text user
.c create text 15 36 -text nice
.c create text 15 61 -text syst
.c create text 15 86 -text idle
pack .c
wm title . "CPU-Usage"


# zyklische Routine ermittelt und zeichnet CPU-Last
proc cpu_usage {} {
	global old_o

	# Werte ermitteln (via /proc/stat)
	set o [exec head -n 1 /proc/stat]
	# cpu  424653 8316 84258 5428160 11823 2490 827 0 0
	set user [expr [lindex $o 1] - [lindex $old_o 1]]
	set nice [expr [lindex $o 2] - [lindex $old_o 2]]
	set syst [expr [lindex $o 3] - [lindex $old_o 3]]
	set idle [expr [lindex $o 4] - [lindex $old_o 4]]
	set cpu_all [expr $user + $nice + $syst + $idle]
	set user [expr $user * 100.0 / $cpu_all]
	set nice [expr $nice * 100.0 / $cpu_all]
	set syst [expr $syst * 100.0 / $cpu_all]
	set idle [expr $idle * 100.0 / $cpu_all]
	set old_o $o
	
	# vorhergehendes Bild loeschen
	.c delete graph

	# Balken berechnen/ausgeben
	.c create rectangle 30 0   [expr 30 + round($user * 3)] 25  -fill blue   -tags graph
	.c create rectangle 30 26  [expr 30 + round($nice * 3)] 50  -fill yellow -tags graph
	.c create rectangle 30 51  [expr 30 + round($syst * 3)] 75  -fill red    -tags graph
	.c create rectangle 30 76  [expr 30 + round($idle * 3)] 100 -fill green  -tags graph

	# Prozentwert ausgeben
	.c create text 350 10 -text [format "%6.2f%%" $user] -tags graph
	.c create text 350 36 -text [format "%6.2f%%" $nice] -tags graph
	.c create text 350 61 -text [format "%6.2f%%" $syst] -tags graph
	.c create text 350 86 -text [format "%6.2f%%" $idle] -tags graph

	# Routine nach 0,5 s wieder aufrufen
	after 500 cpu_usage
}


# zyklischen Routine starten
set old_o {0 0 0 0 0}
cpu_usage

